﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using SlimDX;
using SlimDX.DirectInput;

namespace PolledDevices
{
    /// <summary>
    /// 
    /// </summary>
    public class PolledJoystickEventArgs : System.EventArgs
    {
        /// <summary>
        /// 
        /// </summary>
        public SlimDX.DirectInput.JoystickState State;
        
        /// <summary>
        /// 
        /// </summary>
        public int Button;

        /// <summary>
        /// 
        /// </summary>
        /// <param name="s"></param>
        public PolledJoystickEventArgs(JoystickState s)
            : this(s, -1)
        {
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="s"></param>
        /// <param name="button"></param>
        public PolledJoystickEventArgs(JoystickState s, int button)
        {
            this.State = s;
            this.Button = button;
        }

        /// <summary>
        /// 
        /// </summary>
        public int X
        {
            get { return this.State.X; }
        }

        /// <summary>
        /// 
        /// </summary>
        public int Y
        {
            get { return this.State.Y; }
        }

        /// <summary>
        /// 
        /// </summary>
        public int Z
        {
            get { return this.State.Z; }
        }

        /// <summary>
        /// 
        /// </summary>
        public int Rx
        {
            get { return this.State.RotationX; }
        }

        /// <summary>
        /// 
        /// </summary>
        public int Ry
        {
            get { return this.State.RotationY; }
        }

        /// <summary>
        /// 
        /// </summary>
        public int Rz
        {
            get { return this.State.RotationZ; }
        }

        /// <summary>
        /// 
        /// </summary>
        public Point Sliders
        {
            get
            {
                int[] sliders = this.State.GetSliders();
                return new Point(sliders[0], sliders[1]);
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public int Pov
        {
            get
            {
                int[] pov = this.State.GetPointOfViewControllers();
                return pov[0];
            }
        }
    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public delegate void PolledJoystickEventHandler(object sender, PolledJoystickEventArgs e);
}
